//
// Authors:
//   Patrick Cernko <cernko@ps.uni-sb.de>
//
// Copyright:
//   Patrick Cernko, 2004
//
// Last Change:
//   $Date: 2004/03/15 14:31:44 $ by $Author: errror $
//   $Revision: 1.1.2.1 $
//
#ifndef __JAVA__UNLOCK_WORKER_HH__
#define __JAVA__UNLOCK_WORKER_HH__

#if defined(INTERFACE)
#pragma interface "java/UnlockWorker.hh"
#endif


#include "Seam.hh"
#include "java/Base.hh"
#include "java/Data.hh"


class UnlockWorker : public Worker {
public:
  static UnlockWorker *self;
  
  static void Init() {
    self = new UnlockWorker();
  }

  static void PushFrame(Lock *lock);
  static void Release(StackFrame *sFrame);
  
  virtual u_int GetFrameSize(StackFrame *sFrame);
  virtual Result Run(StackFrame *sFrame);
  virtual Result Handle(word data);
  virtual const char *Identify();
  virtual void DumpFrame(StackFrame *sFrame);
};

#endif
