//
// Author:
//   Leif Kornstaedt <kornstae@ps.uni-sb.de>
//
// Copyright:
//   Leif Kornstaedt, 2002
//
// Last Change:
//   $Date: 2002/09/24 08:50:06 $ by $Author: kornstae $
//   $Revision: 1.3 $
//

#include "java/Authoring.hh"

DEFINE1(floatToIntBits) {
  DECLARE_FLOAT(theFloat, x0);
  union {
    float f;
    u_int x;
  } bytes;
  bytes.f = theFloat->GetValue();
  RETURN_JINT(bytes.x);
} END

DEFINE1(intBitsToFloat) {
  DECLARE_JINT(i, x0);
  union {
    float f;
    u_int x;
  } bytes;
  bytes.x = i;
  RETURN(Float::New(bytes.f)->ToWord());
} END

void NativeMethodTable::java_lang_Float(JavaString *className) {
  Register(className, "floatToIntBits", "(F)I", floatToIntBits, 1, false);
  Register(className, "intBitsToFloat", "(I)F", intBitsToFloat, 1, false);
}
