//
// Author:
//   Leif Kornstaedt <kornstae@ps.uni-sb.de>
//
// Copyright:
//   Leif Kornstaedt, 2002-2003
//
// Last Change:
//   $Date: 2004/03/15 09:53:58 $ by $Author: errror $
//   $Revision: 1.6.2.1 $
//

#ifndef __JAVA_HH__
#define __JAVA_HH__

#define JAVA_FOREIGN

#include "Seam.hh"
#include "java/Base.hh"
#include "java/Data.hh"
#include "java/ThrowWorker.hh"
#include "java/NativeMethodTable.hh"
#include "java/JavaByteCode.hh"
#include "java/ClassInfo.hh"
#include "java/ClassFile.hh"
#include "java/ClassLoader.hh"
#ifdef KAFFE_INTERPRETER
#  include "java/KaffeInterpreter.hh"
#else
#  include "java/ByteCodeInterpreter.hh"
#endif
#include "java/JavaLanguageLayer.hh"
#include "java/Startup.hh"
#include "java/Authoring.hh"

#endif
